from GUI import *
import os
import commands
import sys
import inspect
import cmd
from numpy import integer
import code
from compiler.ast import Node
this_dir = os.path.dirname(inspect.getfile(inspect.currentframe()))
src_dir = os.path.join(this_dir, '..')
sys.path.insert(0, src_dir)
import lib2to3
from lib2to3.pgen2 import driver
from lib2to3 import pygram, pytree
import meta.asttools
import lib2to3
import tokenize
import re
import ast          
import copy

nodeData = {}   # THIS GLOBAL DICTIONARY IS USED BECAUSE THE AST MODULE DOES NOT ALLOW US TO PASS ARGUEMENTS TO VISITORS OR HAVE
                # THEM RETURN VALUES, SO WE USE A GLOBAL DICTIONARY GIVE ARGUEMENTS AND TO STORE VALUES INSTEAD OF RETURNING
# CMD LOOP STUFF, CALLED IF YOU DONT USE THE GUI
class arguementInput(cmd.Cmd):
    global joe;
    def do_generateAdapt(self,line):
        genADAPT(line.split(' ',3)[0], line.split(' ',3)[1],line.split(' ',3)[2])
    def do_generateObserv(self,line):
        genOBSERV(line.split(' ',3)[0], line.split(' ',3)[1],line.split(' ',3)[2])
    def do_generateDec(self,line):
        lineDotSplit = line.split()
        if len(lineDotSplit) == 2:
            genDec(lineDotSplit[0], lineDotSplit[1],'Generic')
        else:
            genDec(lineDotSplit[0],lineDotSplit[1],lineDotSplit[2])
    def do_generateFactory(self,line):
        lineDotSplit = line.split()
        genFact(lineDotSplit[0],lineDotSplit[1])
    def do_generateClassDec(self,line):
        lineDotSplit = line.split( );
        genClassDec(lineDotSplit[0],lineDotSplit[1]);
    def complete_tokenize(self,text,line,begidx,endidx):
        global joe
        if not text:
            completions = joe[:]
        else:
            completions = [f
                            for f in joe
                            if f.startswith(text)]
        return completions
def openAndParse(filen): #HELPER FUNCTION TO OPEN THE GIVEN FILE, RETURN AST
    token(filen) # THIS CREATES A FILE WITH COMMENTS REPLACED WITH NAME FILE_COM3.PY
    filen = filen[:-3]+"_COM.py"
    with open(filen) as f:
        code = f.read()
    tree = ast.parse(code) #CREATE AST FROM CODE
    return tree 

def writeToSource(tree,filen): #HELPER FUNCITON TO WRITE AST TO FILE AS SOURCE CODE
    source = meta.asttools.dump_python_source(tree)
    newfile = filen
    outputfile = open(newfile,'w+')
    outputfile.write(source)
    outputfile.close()
    return "attempting to write source code new file: "+findandreplace(newfile) #THIS PUTS THE COMMENTS BACK AS THEY SHOULD BE

##############################
# ADAPTOR PATTERN GENERATIOM #
##############################
def genADAPT(filen,classname,abstractclass):
    global nodeData
    nodeData['class'] = classname
    nodeData['abstract']=abstractclass

    tree = openAndParse(filen) # open file - replace comments - make tree
    genVisitor().visit(tree)
    #Create new node to add to the ast#
    initNode = createInitNode() #Create a generic init function, that is blank execpt for self.object = object
    newNode = ast.ClassDef()
    newNode.body = []
    for item in nodeData['AbstractNode'].body:
        if isinstance(item,ast.FunctionDef):
            joe = copy.deepcopy(item) # copy the item so it does not modify the original target class when modifying the adaptor
            joe.body = []
            newNode.body.append(joe)

    newNode.body.insert(0,initNode)
    newNode.body.append(createGetattr())
    newNode.name = "{}{}{}".format(nodeData['adaptee'].name,nodeData['AbstractNode'].name.title(),'Adapter')
    newNode.bases = [ast.Name(ctx=ast.Load(), id=nodeData['AbstractNode'].name)]
    newNode.decorator_list = nodeData['AbstractNode'].decorator_list
    nodeData['adapt']= newNode

    #add todos to the function bodies

    genTransformer().visit(nodeData['adapt'])
    #add the new node to the tree with this transformer
    genTransformer().visit(tree)
    #generate code, and make comment strings into real comments, then write result out to file
    result = writeToSource(tree, "{}_COM2.py".format(filen[:-3]))
    print result
    #Return result incase user is doing this from a GUI
    return result
def createInitNode():
    return ast.FunctionDef(args=ast.arguments(args=[ast.Name(ctx=ast.Param(), 
                                                                  id='self'), 
                                                             ast.Name(ctx=ast.Param(), 
                                                                  id='object')], 
                                                       defaults=[], 
                                                       kwarg=None, 
                                                       vararg=None), 
                                        body=[ast.Assign(targets=[ast.Attribute(attr='object', 
                                                                        ctx=ast.Store(), 
                                                                        value=ast.Name(ctx=ast.Load(), 
                                                                                   id='self'))], 
                                                     value=ast.Name(ctx=ast.Load(), 
                                                                id='object'))], 
                                        decorator_list=[], 
                                        name='__init__')
def createGetattr():
    return ast.FunctionDef(args=ast.arguments(args=[ast.Name(ctx=ast.Param(), 
                                                                  id='self'), 
                                                             ast.Name(ctx=ast.Param(), 
                                                                  id='attr')], 
                                                       defaults=[], 
                                                       kwarg=None, 
                                                       vararg=None), 
                                        body=[ast.Return(value=ast.Call(args=[ast.Attribute(attr='object', 
                                                                                ctx=ast.Load(), 
                                                                                value=ast.Name(ctx=ast.Load(), 
                                                                                           id='self')), 
                                                                      ast.Name(ctx=ast.Load(), 
                                                                           id='attr')], 
                                                                func=ast.Name(ctx=ast.Load(), 
                                                                          id='getattr'), 
                                                                keywords=[], 
                                                                kwargs=None, 
                                                                starargs=None))], 
                                        decorator_list=[], 
                                        name='__getattr__')

class genVisitor(ast.NodeVisitor):
    def visit_ClassDef(self, node):
        global nodeData
        if node.name==nodeData['abstract']:
            nodeData['AbstractNode']=node 
        if node.name ==nodeData['class']:
            nodeData['adaptee']=node
class genTransformer(ast.NodeTransformer):
    #TODO
    def visit_Module(self,node):
        node.body.insert(len(node.body)-1,nodeData['adapt'])
        newNode = node
        ast.copy_location(newNode, node)
        ast.fix_missing_locations(newNode)
        return newNode
    def visit_ClassDef(self,node):
        
        if node.name == nodeData['abstract']:
            return node
        if node.name==nodeData['adapt'].name:
            for fun in node.body:
                if isinstance(fun,ast.FunctionDef):
                    if fun.name != "__getattr__" and fun.name != "__init__":
                      fun.body.insert(0,ast.Expr(value=ast.Str(s="#COMMENT:#TODO")))
                    
        newNode = node

        ast.copy_location(newNode, node) # swaps the nodes
        ast.fix_missing_locations(newNode)#resets the col / row to be corect for generation later
        return newNode
###########################
# END OF CODE FOR ADAPTOR #
###########################



#######################################
# THE REAL OBSERVER PATTERN GENORATOR #
#######################################
def genOBSERV(filen,Observable,Observer):
    #storing the names of the classes we need in a global, this way it can been seen from ast visitors
    #in the ast library visitors are impleneted in a certain way, that does not allow us to give extra arguements
    global nodeData
    nodeData['ObservableClass'] = Observable
    nodeData['ObserverClass'] = Observer
    #save comments with tokenizer
    tree = openAndParse(filen) # open file - replace comments - make tree

    newFile = generatedObserver();

    source2 = meta.asttools.dump_python_source(newFile)
    newfile2 = "{}{}".format("observerGenerated",".py")
    outputfile2 = open(newfile2,'w+')# creats in same directory as this file :/ future   work
    outputfile2.write(source2)
    outputfile2.close()
    newfile3 = findandreplace(newfile2)
    with open(newfile3) as f:
        output = f.read()
    outputfile4 = open(newfile2,'w+')
    outputfile4.write(output)
    outputfile4.close()
    OVisitor().visit(tree)
    OTransformer().visit(tree)
    OTransformer2().visit(tree)
    result = writeToSource(tree, "{}_COM2.py".format(filename[:-3]))
    print result
    return result


class OTransformer(ast.NodeTransformer):
    def visit_ClassDef(self,node):
        if node.name==nodeData['ObservableClass']:
            Aname = ast.Name()
            Aname.ctx = ast.Load()
            Aname.id = 'Observable'
            node.bases.append(Aname)

            for fun in node.body:
                
                if isinstance(fun,ast.FunctionDef):
                    if fun.name=='__init__':
                        fun.body.append(superline())# Superline is defined under this class, it is an expr node
        if node.name==nodeData['ObserverClass']:
            Aname = ast.Name()
            Aname.ctx = ast.Load()
            Aname.id = 'Observer'
            node.bases.append(Aname)

        newNode = node

        ast.copy_location(newNode, node)
        ast.fix_missing_locations(newNode)
        return newNode
class OTransformer2(ast.NodeTransformer):
    def visit_Module(self,node):
       importLine = ast.ImportFrom(level=0, module='observerGenerated', names=[ast.alias(asname=None, 
                   name='Observable'), ast.alias(asname=None, name='Observer')])
       node.body.insert(0,importLine)
       newNode = node
       ast.copy_location(newNode, node)
       ast.fix_missing_locations(newNode)
       return newNode

class OVisitor(ast.NodeVisitor):
    def visit_ClassDef(self,node):
        print ""

#this is just a line of code represented as an ast, it needs to be added to the init for the observable, its here to make 
#our code look slightly nicer
def superline():
    return ast.Expr(value=ast.Attribute(attr='List', ctx=ast.Load(),value=ast.Name(ctx=ast.Load(), id='Observable')))

###############################################################################################################################
#this creates a module containing generic, iheritable observer, and observable classes that will be used for the pattern #
###############################################################################################################################
def generatedObserver():
    # the code that follows creates an abstract syntax tree in the most consise way possible, it is very hard to read
    # the general structure is a follows, there is really no need to read this though.
    #   ------------------------------------MODULE----------------------------------------
    #               /                          |                                \
    #         ClassDef                      ClassDef                          ClassDef
    #             |              /             |          \                 /          \
    #        functionDef     FunctionDef FunctionDef FunctionDef      FunctionDef FunctionDef
    return ast.Module(body=[ast.ClassDef(bases=[ast.Name(ctx=ast.Load(), 
                                  id='type')], 
                      body=[ast.FunctionDef(args=ast.arguments(args=[ast.Name(ctx=ast.Param(), 
                                                                  id='cls')], 
                                                       defaults=[], 
                                                       kwarg=None, 
                                                       vararg=None), 
                                        body=[ast.If(body=[ast.Assign(targets=[ast.Attribute(attr='_observers', 
                                                                                 ctx=ast.Store(), 
                                                                                 value=ast.Name(ctx=ast.Load(), 
                                                                                            id='cls'))], 
                                                              value=ast.List(ctx=ast.Load(), 
                                                                         elts=[]))], 
                                                 orelse=[], 
                                                 test=ast.Compare(comparators=[ast.Name(ctx=ast.Load(), 
                                                                                id='None')], 
                                                              left=ast.Call(args=[ast.Name(ctx=ast.Load(), 
                                                                                   id='cls'), 
                                                                              ast.Str(s='_observers'), 
                                                                              ast.Name(ctx=ast.Load(), 
                                                                                   id='None')], 
                                                                        func=ast.Name(ctx=ast.Load(), 
                                                                                  id='getattr'), 
                                                                        keywords=[], 
                                                                        kwargs=None, 
                                                                        starargs=None), 
                                                              ops=[ast.Is()]))], 
                                        decorator_list=[ast.Name(ctx=ast.Load(), 
                                                             id='property')], 
                                        name='List')], 
                      decorator_list=[], 
                      name='metaClass'), 
             ast.ClassDef(bases=[ast.Name(ctx=ast.Load(), 
                                  id='object')], 
                      body=[ast.Assign(targets=[ast.Name(ctx=ast.Store(), 
                                                 id='__metaclass__')], 
                                   value=ast.Name(ctx=ast.Load(), 
                                              id='metaClass')), 
                            ast.FunctionDef(args=ast.arguments(args=[ast.Name(ctx=ast.Param(), 
                                                                  id='self')], 
                                                       defaults=[], 
                                                       kwarg=None, 
                                                       vararg=None), 
                                        body=[ast.Pass()], 
                                        decorator_list=[], 
                                        name='__init__'), 
                            ast.FunctionDef(args=ast.arguments(args=[ast.Name(ctx=ast.Param(), 
                                                                  id='self'), 
                                                             ast.Name(ctx=ast.Param(), 
                                                                  id='observer')], 
                                                       defaults=[], 
                                                       kwarg=None, 
                                                       vararg=None), 
                                        body=[ast.Expr(value=ast.Call(args=[ast.Name(ctx=ast.Load(), 
                                                                         id='observer')], 
                                                              func=ast.Attribute(attr='append', 
                                                                             ctx=ast.Load(), 
                                                                             value=ast.Attribute(attr='_observers', 
                                                                                             ctx=ast.Load(), 
                                                                                             value=ast.Name(ctx=ast.Load(), 
                                                                                                        id='Observable'))), 
                                                              keywords=[], 
                                                              kwargs=None, 
                                                              starargs=None))], 
                                        decorator_list=[], 
                                        name='register_observer'), 
                            ast.FunctionDef(args=ast.arguments(args=[ast.Name(ctx=ast.Param(), 
                                                                  id='self')], 
                                                       defaults=[], 
                                                       kwarg='kwargs', 
                                                       vararg='args'), 
                                        body=[ast.For(body=[ast.Expr(value=ast.Call(args=[ast.Name(ctx=ast.Load(), 
                                                                                   id='self')], 
                                                                        func=ast.Name(ctx=ast.Load(), 
                                                                                  id='observer'), 
                                                                        keywords=[], 
                                                                        kwargs=ast.Name(ctx=ast.Load(), 
                                                                                    id='kwargs'), 
                                                                        starargs=ast.Name(ctx=ast.Load(), 
                                                                                      id='args')))], 
                                                  iter=ast.Attribute(attr='_observers', 
                                                                 ctx=ast.Load(), 
                                                                 value=ast.Name(ctx=ast.Load(), 
                                                                            id='Observable')), 
                                                  orelse=[], 
                                                  target=ast.Name(ctx=ast.Store(), 
                                                              id='observer'))], 
                                        decorator_list=[], 
                                        name='notify_observers')], 
                      decorator_list=[], 
                      name='Observable'), 
             ast.ClassDef(bases=[ast.Name(ctx=ast.Load(), 
                                  id='object')], 
                      body=[ast.FunctionDef(args=ast.arguments(args=[ast.Name(ctx=ast.Param(), 
                                                                  id='self'), 
                                                             ast.Name(ctx=ast.Param(), 
                                                                  id='observable')], 
                                                       defaults=[], 
                                                       kwarg=None, 
                                                       vararg=None), 
                                        body=[ast.Pass()], 
                                        decorator_list=[], 
                                        name='__init__'), 
                            ast.FunctionDef(args=ast.arguments(args=[ast.Name(ctx=ast.Param(), 
                                                                  id='self'), 
                                                             ast.Name(ctx=ast.Param(), 
                                                                  id='observable')], 
                                                       defaults=[], 
                                                       kwarg='kwargs', 
                                                       vararg='args'), 
                                        body=[ast.Print(dest=None, 
                                                    nl=True, 
                                                    values=[ast.Str(s='TODO - Implement this, for now it just prints!')]), 
                                              ast.Print(dest=None, 
                                                    nl=True, 
                                                    values=[ast.Tuple(ctx=ast.Load(), 
                                                                  elts=[ast.Str(s='Got'), 
                                                                        ast.Name(ctx=ast.Load(), 
                                                                             id='args'), 
                                                                        ast.Name(ctx=ast.Load(), 
                                                                             id='kwargs'), 
                                                                        ast.Str(s='From'), 
                                                                        ast.Name(ctx=ast.Load(), 
                                                                             id='observable')])])], 
                                        decorator_list=[], 
                                        name='notify')], 
                      decorator_list=[], 
                      name='Observer')])

####################################
# METHOD DECORATOR GENERATION CODE #
####################################
def genDec(filen, name, arg): #THIS CODE IS NOT CURRENTLY USED CODE, BUT DOES WORK
    global nodeData
    nodeData['FunctionName'] = name
    nodeData['type'] = arg
    
    if arg == 'arg': # if statemnent deciding if there will be args or not
        nodeData['decArgs']=ast.Call(args=[ast.Str(s='example argument')], 
            func=ast.Name(ctx=ast.Load(), id='decoratorWargs{}'.format(nodeData['FunctionName'])), keywords=[], kwargs=None, starargs=None)
    else:
        nodeData['decArgs'] = ast.Name(ctx=ast.Load(), id='decorator{}'.format(nodeData['FunctionName']))

    #nodeData['ObserverClass'] = Observer
    token(filen)

    filen = filen[:-3]+"_COM.py"
    with open(filen) as f:
        code = f.read()
    print code
    tree = ast.parse(code)
    decTransformer1().visit(tree)
    decTransformer2().visit(tree)
    print meta.asttools.dump_python_source(tree)
    result = writeToSource(tree, "{}_COM2.py".format(filen[:-3]))
    print result
    return result



class decTransformer1(ast.NodeTransformer):
    def visit_Module(self,node):
        decorator = getGenericDecorator()
        node.body.insert(0,decorator)
        newNode = node
        ast.copy_location(newNode, node)
        ast.fix_missing_locations(newNode)
        return newNode
class decTransformer2(ast.NodeTransformer):
    def visit_FunctionDef(self,node):
        if node.name == nodeData['FunctionName']:
            node.decorator_list.append(nodeData['decArgs'])
        newNode = node
        ast.copy_location(newNode, node)
        ast.fix_missing_locations(newNode)
        return newNode

def getGenericDecorator():
    if nodeData['type'] == 'arg':
        return ast.ClassDef(bases=[ast.Name(ctx=ast.Load(), 
                                  id='object')], 
                      body=[ast.FunctionDef(args=ast.arguments(args=[ast.Name(ctx=ast.Param(), 
                                                                  id='self'), 
                                                             ast.Name(ctx=ast.Param(), 
                                                                  id='arg1')], 
                                                       defaults=[], 
                                                       kwarg=None, 
                                                       vararg=None), 
                                        body=[ast.Assign(targets=[ast.Attribute(attr='arg1', 
                                                                        ctx=ast.Store(), 
                                                                        value=ast.Name(ctx=ast.Load(), 
                                                                                   id='self'))], 
                                                     value=ast.Name(ctx=ast.Load(), 
                                                                id='arg1'))], 
                                        decorator_list=[], 
                                        name='__init__'), 
                            ast.FunctionDef(args=ast.arguments(args=[ast.Name(ctx=ast.Param(), 
                                                                  id='self'), 
                                                             ast.Name(ctx=ast.Param(), 
                                                                  id='f')], 
                                                       defaults=[], 
                                                       kwarg=None, 
                                                       vararg=None), 
                                        body=[ast.FunctionDef(args=ast.arguments(args=[], 
                                                                         defaults=[], 
                                                                         kwarg=None, 
                                                                         vararg='args'), 
                                                          body=[ast.Print(dest=None, 
                                                                      nl=True, 
                                                                      values=[ast.Str(s='Alternate decorator code goes here')]), 
                                                                ast.Print(dest=None, 
                                                                      nl=True, 
                                                                      values=[ast.Tuple(ctx=ast.Load(), 
                                                                                    elts=[ast.Str(s='decorator args: '), 
                                                                                          ast.Attribute(attr='arg1', 
                                                                                                    ctx=ast.Load(), 
                                                                                                    value=ast.Name(ctx=ast.Load(), 
                                                                                                               id='self'))])]), 
                                                                ast.Expr(value=ast.Call(args=[], 
                                                                                func=ast.Name(ctx=ast.Load(), 
                                                                                          id='f'), 
                                                                                keywords=[], 
                                                                                kwargs=None, 
                                                                                starargs=ast.Name(ctx=ast.Load(), 
                                                                                              id='args')))], 
                                                          decorator_list=[], 
                                                          name='wrapped_func'), 
                                              ast.Return(value=ast.Name(ctx=ast.Load(), 
                                                                id='wrapped_func'))], 
                                        decorator_list=[], 
                                        name='__call__')], 
                      decorator_list=[], 
                      name='decoratorWargs{}'.format(nodeData['FunctionName']))


    return ast.ClassDef(bases=[ast.Name(ctx=ast.Load(), 
                                  id='object')], 
                      body=[ast.FunctionDef(args=ast.arguments(args=[ast.Name(ctx=ast.Param(), 
                                                                  id='self'), 
                                                             ast.Name(ctx=ast.Param(), 
                                                                  id='func')], 
                                                       defaults=[], 
                                                       kwarg=None, 
                                                       vararg=None), 
                                        body=[ast.Assign(targets=[ast.Attribute(attr='func', 
                                                                        ctx=ast.Store(), 
                                                                        value=ast.Name(ctx=ast.Load(), 
                                                                                   id='self'))], 
                                                     value=ast.Name(ctx=ast.Load(), 
                                                                id='func'))], 
                                        decorator_list=[], 
                                        name='__init__'), 
                            ast.FunctionDef(args=ast.arguments(args=[ast.Name(ctx=ast.Param(), 
                                                                  id='self')], 
                                                       defaults=[], 
                                                       kwarg=None, 
                                                       vararg='args'), 
                                        body=[ast.Print(dest=None, 
                                                    nl=True, 
                                                    values=[ast.Str(s='Alternate decorator code goes here')]), 
                                              ast.Expr(value=ast.Call(args=[], 
                                                              func=ast.Attribute(attr='func', 
                                                                             ctx=ast.Load(), 
                                                                             value=ast.Name(ctx=ast.Load(), 
                                                                                        id='self')), 
                                                              keywords=[], 
                                                              kwargs=None, 
                                                              starargs=ast.Name(ctx=ast.Load(), 
                                                                            id='args')))], 
                                        decorator_list=[], 
                                        name='__call__')], 
                      decorator_list=[], 
                      name='decorator{}'.format(nodeData['FunctionName']))

###########################################
# FACTORY FOR SUPER CLASS GENERATION CODE # 
###########################################
def genFact(filen,classn):
    global nodeData 
    nodeData["type"]=classn 
    nodeData['subclasses']=[]

    tree = openAndParse(filen) # open file - replace comments - make tree

    countVisitor().visit(tree)      # look for abstract class
    FactVisitor().visit(tree)       # look for subclasses
    FactTransformer().visit(tree)   # put in the factory

    result = writeToSource(tree, "{}_COM2.py".format(filen[:-3])) # write out to source code
    return result

#################### Dict #######################
# this dictionary contains ket value pairs:     #
#                                               #
# THE KEY will be a nodes name (a string)       #
#                                               #
# THE VALUE will be the list of arguemnets      #
# for the init of the class, excluding the self #
# arguements                                    #
#################################################
Dict = {}

# # # # # # countVisitor(ast.NodeVisitor) # # # #
# this visitor stores the name and postion of   #
# the abstract class which we are making the    #
# abstract factory for                          #
# # # # # # # # # # # # # # # # # # # # # # # # #
class countVisitor(ast.NodeVisitor):
    def visit_Module(self,node):
        i=0
        for x in node.body:
            i+=1
            if isinstance(x,ast.ClassDef):
                if x.name == nodeData['type']:
                    nodeData['pos'] = i


# # # # # # FactVisitor(ast.NodeVisitor) # # # # #
# this visitor stores the name and arguements of #
# the subclasses which inherit the abstract      #
# class. this information is used later. The     #
# transformer calls getClassFatory which then    #
# calls classfactoryfuncs() which is where this  #
# information is actually used to make fuctions  #            
# # ## # # # # # # # # # # # # # # # # # # # # # #
class FactVisitor(ast.NodeVisitor):
    global nodeData # currently this is used for holding the name of the abstract class
    global Dict  # looks like {'name' : [arg1,arg2] , 'name2' : [arg1] , ... }
    def visit_ClassDef(self,node):
        for b in node.bases:
            if b.id == nodeData['type']: #if this class inherits the abstract class
                nodeData['subclasses'].append(node.name); #save the name of this subclass
                for function in node.body:
                    if function.name == '__init__':
                        Dict[node.name]=function.args.args[1:] #saves the see comment at line 562
                break;

# # # # # # # FactTransformer # # # # # # # #
# calls functions to create the factory and #
# adds the new factory to the module body   #
# # # # # # # # # # # # # # # # # # # # # # #
class FactTransformer(ast.NodeTransformer):
    global nodeData
    def visit_Module(self,node):
        
        node.body.insert(nodeData['pos'],getClassFact())
        
        newNode = node
        ast.copy_location(newNode, node)
        ast.fix_missing_locations(newNode)
        
        return newNode




# # # # #  classfactoryfuncs(version) # # # # # # 
# creates factory methods given the name of the #
# object to be created, and the dictionary of   #
# arguemnts that was set up in the FactVisitor  #
#                                               #
# THIS FUNCTION IS CALLED BY getClassFact()     #
# # # # # # # # # # # # # # # # # # # # # # # # #
def classfactoryfuncs(version):
    
    arg_list = Dict[version] 
    
    fab = 'fabricate_{}'.format(version) #create the name for this factory method
    clsargs = arg_list #the list of arguements
    clsargs.insert(0,ast.Name(ctx=ast.Param(), id='cls'))
    ###
    # okay so this is going to be reeeally hard to read, but ill just tell you what it does lol
    #
    # creates a function definition whoes arguements are the same as the init for the class 
    # factory is creating instances of, but with self replaced with cls 
    #
    # the body of this function is a comment saying "Your code goes here", followed by a return 
    # statment that returns a new instance of the class to be created ("version" contains the 
    # name of this class)
    #
    # so it looks like the following for a class with arguemnts ARG1,ARG2 and name "NAME"
    #    @classmethod
    #    def fabricate_NAME(cls, ARG1, ARG2):    
    #        #Your code here...
    #        return NAME(ARG1, ARG2)
    #
    ###
    funct=ast.FunctionDef(  args=ast.arguments( args=clsargs, #the arguemnts with cls at the begining
                                                defaults=[],kwarg=None,vararg=None), 
                            body=[ast.Expr( value=ast.Str(s="#COMMENT:#Your code here...")),
                                ast.Return( value=ast.Call(args=arg_list[1:], # the proper arguemnents for the call
                                            func=ast.Name(ctx=ast.Load(), 
                                                          id=version), #return NAME(arg1,arg2)
                                            keywords=[], 
                                            kwargs=None, 
                                            starargs=None))], 
                            decorator_list=[ast.Name(ctx=ast.Load(), id='classmethod')], # make this fucntion a class method
                            name=fab) #Fabricate_NAME



    """ # if we were to do the above in multiple lines. this would be how we would do it
    funct=ast.FunctionDef(args=ast.arguments(args=[],defaults=[], kwarg=None, vararg=None), 
                        body=[], decorator_list=[], name='')

    funct.args.args = clsargs # add the correct arguements 
    funct.body.append(ast.Expr(value=ast.Str(s="#COMMENT:#Your code here..."))) # add a TODO comment

    returnNode = ast.Return(value=ast.Call(args=[],func=ast.Name(ctx=ast.Load(),id=''),
                          keywords=[],kwargs=None, starargs=None)) # generic return of a call
    returnNode.value.func.id = version # call the class we are creating an instance of
    returnNode.value.args = arg_list[1:] # call with correct arguemnts and cls

    fucnt.body.append(returnNode) # add the return to the function body
    funct.decorator_list.append(ast.Name(ctx=ast.Load(),id='classmethod')) #make this a classmethod, so it can always be called
    funct.name = fab # make the name of the function Fabricate_NAME()
    """

    return funct

############## getClassFact #################
# creates a list of all the factory method  #
# and puts then in a class definition this  #
# creates the actual factory class.         #
#############################################
def getClassFact():
    factory = '{}Factory'.format(nodeData['type'])
    functionDefList = []
    for x in nodeData['subclasses']:
        functionDefList.append(classfactoryfuncs(x)) # this call creates function defs
    classdef=ast.ClassDef(  bases=[], 
                            body=functionDefList, #append all the requred functions set ^
                            decorator_list=[], 
                            name=factory) # give it the correct name
    return classdef



####################################################
# CLASS DECORATOR, FOR PYHTON, IN A CERTAIN WAY... #
####################################################
def genClassDec(filen,classname):
    global nodeData
    # saving the arguements for use in node visitors
    nodeData['class']=classname 
    nodeData['functions']=[]
    nodeData['pos'] = 0

    tree = openAndParse(filen) # open file - replace comments - make tree

    classFindVisitor().visit(tree)      # get location of the class to be decorated
    functionsVisitor().visit(tree)      # gets all the functions names from the class
    addDecTransformer().visit(tree)     # add in the 2 functions to the tree
    modClassTransformer().visit(tree)   # add the decorator to the class

    result = writeToSource(tree, "{}_COM2.py".format(filen[:-3])) # write out to source
    return result

############# classFindVisitor(ast.NodeVisitor) ##############
# Saved the position of the class to be decorator, so we can #
# add the decorator before it in the code where it should be #
##############################################################
class classFindVisitor(ast.NodeVisitor):
    def visit_module(self,node):
        for x in range(0,len(node.body)):
            if isinstance(node.body[x],ast.ClassDef):
                if node.body[x].name == nodeData['class']:
                    nodeData['pos'] = x # save the position in dictionary for use by the transformer

############# functionsVisitor(ast.NodeVisitor) ##############
# Saves the names of all the methods of the original class   #
##############################################################
class functionsVisitor(ast.NodeVisitor):
    global nodeData
    def visit_ClassDef(self,node):
        if node.name == nodeData['class']:
            for n in node.body:
                if isinstance(n,ast.FunctionDef):
                    if n.name != '__init__': # we decided to not overwrite the __init__ by default
                        nodeData['functions'].append(n.name)

######### addDecTransformer(ast.NodeTransformer) #############
# this transformer adds the entire class decorator into the  #
# tree before the class to be decorated. the class decorator #
# is created by getClassDecorator() see that function for    #
# logic about the generation of the decorator itself         #
##############################################################
class addDecTransformer(ast.NodeTransformer):
    global nodeData
    def visit_Module(self,node):
        
        node.body.insert(nodeData['pos'],ast.Expr(value=ast.Str(s='#COMMENT:'))) # add whitespace for readability
        node.body.insert(nodeData['pos'],getClassDecorator()) # getClassDecorator() makes everything
        newNode = node
        ast.copy_location(newNode, node)
        ast.fix_missing_locations(newNode)
        return newNode
######### modClassTransformer(ast.NodeTransformer) ###########
# this just adds the decorator that was added to the tree by #
# addDecTransformer(ast.NodeTransformer) to the list of      #
# decorators of the class we are generating the pattern for  #
# ie puts @class_decorator at the begining of the class      #
##############################################################
class modClassTransformer(ast.NodeTransformer):
    global nodeData
    def visit_ClassDef(self,node):
        if node.name == nodeData['class']:
            argslist = []
            for st in nodeData['functions']:
                j=ast.Str(s=st)
                argslist.append(j)
            node.decorator_list.append( ast.Call(args=argslist, func=ast.Name(ctx=ast.Load(), id='class_decorator'),
                                        keywords=[],kwargs=None, starargs=None)) # decorator with args
        newNode = node
        ast.copy_location(newNode, node)
        ast.fix_missing_locations(newNode)
        return newNode

#########################  EXPLINATION OF THE CODE WE ARE GENERATING #################################
# okay so we need to make the whole friggin class decorator implemented correctly as to
# not modify the behavious of classes that inherit it, and to allow the user to only decorate
# the parts of the class they wish to decorate with out knowing the context of the code, so
# we are going to create a decorator that overwrites the class_builder function, and builds us
# a class that inherits the original, to keep all its information, while also replacing the original
# this is oging to look like a function definitions inside a class definition inside a funtion 
# definition that inside another function definition.
# we need to create approprite names for these functions and classes, which will be done, by using
# the names of the original class and its methods. 
######################################################################################################



# # # # # # # # # # # # # # # # # # # # # # # # # # getMethodDecorators # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
# getMethodDecorators() creates a function definition that is a decorator for a method of the class we implementing this pattern for
# inside this function definition the function that will be run instead of the original method, this function is returned by decorator
# so that it can be returned by the getattribute magic method we overwrote (read the class decorator section of the paper)
# it will end up looking something like this if the original class is called "example" and its methods are called function_
# decorator for the method called "function1" of  "class example"
# def function1_decorator(self, example_function1): # this second arguement is the original function      
#                 def decorator(*args ,**kwargs):          
#                     print ('Inside the decorator for function1 with args: ', args)
#                     return example_function1(*args , **kwargs) # here we call the original function the user can remove this
#                 return decorator 
def getMethodDecorators():
    listOfFunctions = []
    global nodeData

    #loop through all the method names saved by functionsVisitor and create decorators for all of them
    for x in range(0,len(nodeData['functions'])): 
        fn = nodeData['functions'][x]   # fn =  function name
        cn = nodeData['class']          # cn = class name
        cn_fn = "{}_{}".format(cn,fn)   # class name _ function name
        fn_dec = "{}_decorator".format(fn) # function name followed by the word decorator
        examplestr = 'Inside the decorator for {} with args: '.format(fn) # string for use in a default print statment
        cn_cd='{}_ClassDecorator'.format(cn) # class name followed by _ClassDecorator 
        # this is the actual function definition, so i will put a comment any where we are adding in relevent information
        thefun = ast.FunctionDef(args=ast.arguments(args=[ast.Name(ctx=ast.Param(), 
                                                                  id='self'), # use self as the first arguement
                                                            ast.Name(ctx=ast.Param(), 
                                                                  id=cn_fn)], # classname_functionname ie 'example_function1'
                                                       defaults=[], 
                                                       kwarg=None, 
                                                       vararg=None), 
                                body=[ast.FunctionDef(args=ast.arguments(args=[], 
                                                                 defaults=[], 
                                                                 kwarg='kwargs', 
                                                                 vararg='args ,'),  # The decorator takes in the same args as the
                                                                                    #   original class, these are saved in *args
                                                                                    #   the comma is there, bc meta wont generate
                                                                                    #   the source code right otherwise so a 
                                                                                    #   comma is place there manually 'args ,'
                                                  body=[ast.Print(dest=None,        
                                                              nl=True, 
                                                              values=[ast.Tuple(ctx=ast.Load(), 
                                                                            elts=[ast.Str(s=examplestr), 
                                                                                  ast.Name(ctx=ast.Load(), 
                                                                                       id='args')])]), # just an example print statement

                                                        # this return statement calls the original function, which was passed in as an
                                                        # arguemnt cn_fn you can see cn_fn used in the args for the outer functionDef
                                                        # ie return example_function1(*args , **kwargs)
                                                        ast.Return(value=ast.Call(args=[], 
                                                                          func=ast.Name(ctx=ast.Load(), 
                                                                                    id=cn_fn), # cn_fn ie 'example_function1'
                                                                          keywords=[], 
                                                                          kwargs=ast.Name(ctx=ast.Load(), 
                                                                                      id='kwargs'), 
                                                                          starargs=ast.Name(ctx=ast.Load(), 
                                                                                        id='args ')))], # end of return statement

                                                  decorator_list=[], 
                                                  name='decorator'), # function is called decorator
                                      ast.Return(value=ast.Name(ctx=ast.Load(), 
                                                        id='decorator'))],  # return the function called decorator
                                decorator_list=[], 
                                name=fn_dec) # ie 'function1_decorator'
        listOfFunctions.append(ast.Expr(value=ast.Str(s='#COMMENT:'))) # add white space between function defs
        listOfFunctions.append(thefun)
    FYI = '#COMMENT:#FYI - any objects of the original class can be reached using self, ie self.fieldname'
    listOfFunctions.insert(0,ast.Expr(value=ast.Str(s=FYI))) # put a comment saying ^^^^^^^^^^
    listOfFunctions.append(ast.Expr(value=ast.Str(s='#COMMENT:'))) # some white space for readability
    return listOfFunctions # this is a bunch of function defs and white space in between them

def getClassDecorator():
    listOfIfs = []
    #This function creates the entire thing, i have added as a comment below
    # that is what it will look like, given that the class to be decorated is called "example"
    # and that the methods of example are "function1" "function2" "function3" 

    # def class_decorator(*method_names):
    #     def class_rebuilder(cls):    
    #         class decorated_example(cls):        
    #             #FYI - any objects of the original class can be reached using self, ie self.fieldname
                
    #             def function1_decorator(self, example_function1):            
    #                 def decorator(*args ,**kwargs):                
    #                     print ('Inside the decorator for function1 with args: ', args)
    #                     return example_function1(*args , **kwargs)
    #                 return decorator
                
    #             def function2_decorator(self, example_function2):            
    #                 def decorator(*args ,**kwargs):                
    #                     print ('Inside the decorator for function2 with args: ', args)
    #                     return example_function2(*args , **kwargs)
    #                 return decorator
                
    #             def function3_decorator(self, example_function3):            
    #                 def decorator(*args ,**kwargs):                
    #                     print ('Inside the decorator for function3 with args: ', args)
    #                     return example_function3(*args , **kwargs)
    #                 return decorator
                
    #             def __getattribute__(self, attr_name):            
    #                 obj = super(decorated_example, self).__getattribute__(attr_name)
    #                 if (hasattr(obj, '__call__') and (attr_name in method_names)):                
    #                     if (attr_name == 'function1'):                    
    #                         return self.function1_decorator(obj)
                        
    #                     if (attr_name == 'function2'):                    
    #                         return self.function2_decorator(obj)
                        
    #                     if (attr_name == 'function3'):                    
    #                         return self.function3_decorator(obj)
                        
    #                     #TODO - implement any of your own if statments and/or modify the above
                    
    #                 return obj
    #         return decorated_example
    #     return class_rebuilder


    #starting small, building the if that goes in the larger if inside def __getattribute__(self, attr_name):
    #                     if (attr_name == 'function1'):                    
    #                         return self.function1_decorator(obj)          <-,
    #                                                                          \
    #                     if (attr_name == 'function2'):                        \
    #                         return self.function2_decorator(obj)           <--- MAKING THESE 
    #                                                                           /   STORING THEM IN "listOfIfs" VARIABLE
    #                     if (attr_name == 'function3'):                       /
    #                         return self.function3_decorator(obj)          <-'
    for x in range(0,len(nodeData['functions'])):
        fd = "{}_decorator".format(nodeData['functions'][x])
        cd = "{}_ClassDecorator".format(nodeData['class'])
        cn = copy.copy(nodeData['class'])
        NewClass = "{}{}".format("decorated_",cn) 
        theif = ast.If(body=[ast.Return(value=ast.Call(args=[ast.Name(ctx=ast.Load(), 
                                                       id='obj')], 
                                            func=ast.Attribute(attr=fd, # functionName_Decorator 
                                                       ctx=ast.Load(), 
                                                       value=ast.Name(ctx=ast.Load(), id='self')), 
                                            keywords=[], 
                                            kwargs=None, 
                                            starargs=None))], 
                        orelse=[],                            
                        test=ast.Compare())
        theif.test = ast.Compare(comparators=[ast.Str(s=nodeData['functions'][x])], # compair the function name
                                 left=ast.Name(ctx=ast.Load(), id='attr_name'),     # compair with attr_name
                                 ops=[ast.Eq()])                                    # operation is '=='
        listOfIfs.append(theif)

    listOfIfs.append(ast.Expr(value=ast.Str(s='#COMMENT:#TODO - implement any of your own if statments and/or modify the above')))

    body1 = [] # ADDING THE STATEMENTS AT THE START OF def __getattribute__(self, attr_name)
    #
    #                 obj = super(decorated_example, self).__getattribute__(attr_name)  #WILL BE body1[0]
    #                 if (hasattr(obj, '__call__') and (attr_name in method_names)):    #WILL BE body1[1]
    #                       ... 
    #                       ...     <--- THIS BODY IS FILLED WITH THE LIST "listOfIfs" CREATED BY ABOVE FOR LOOP
    #                       ...
    #                 return obj                                                        #WILL BE body1[2]
            
    # add the out super call in body1[0]
    body1.append(ast.Assign( targets=[ast.Name(ctx=ast.Store(),id='obj')],
            value=ast.Call(args=[ast.Name(ctx=ast.Load(), id='attr_name')],
            func=ast.Attribute(attr='__getattribute__', ctx=ast.Load(), 
                value=ast.Call(args=[ast.Name(ctx=ast.Load(), id=NewClass), # NewClass is the name of the class decorator
                    ast.Name(ctx=ast.Load(), id='self')],
                func=ast.Name(ctx=ast.Load(), id='super'), keywords=[], kwargs=None, starargs=None)), 
            keywords=[], kwargs=None, starargs=None)))

    # add the if and ifs inside it in body1[1]
    body1.append(ast.If(body=listOfIfs, # add the list of ifs (listOfIfs) to the inside of the body of a new if statment
                orelse=[],test=ast.BoolOp(op=ast.And(), values=[ast.Call(args=[ast.Name(ctx=ast.Load(), 
                id='obj'), ast.Str(s='__call__')], func=ast.Name(ctx=ast.Load(), id='hasattr'), keywords=[], kwargs=None, starargs=None),
                 ast.Compare(comparators=[ast.Name(ctx=ast.Load(), 
                id='method_names')], left=ast.Name(ctx=ast.Load(), id='attr_name'),ops=[ast.In()])])))

    #add the final return statement in body1[2]
    body1.append(ast.Return(value=ast.Name(ctx=ast.Load(),id='obj'))) #add return obj, outside of all the ifs, instead of using else
    # this list will contain all the functions for the decorator class! 

    listfuns=getMethodDecorators() # CREATE ALL THE FUNCTION DEFs THAT ARE METHOD DECORATORS FOR THE ORIGINAL CLASSES METHODS
    #             def function1_decorator(self, example_function1):            
    #                 def decorator(*args ,**kwargs):                
    #                     print ('Inside the decorator for function1 with args: ', args)
    #                     return example_function1(*args , **kwargs)
    #                 return decorator                                                         <-.
    #                                                                                             \  
    #             def function2_decorator(self, example_function2):                                \
    #                 def decorator(*args ,**kwargs):                                           <--- MAKING THESE 
    #                     print ('Inside the decorator for function2 with args: ', args)           /    SEE getMethodDecorators()
    #                     return example_function2(*args , **kwargs)                              /     FOR LOGIC ON HOW IT WORKS
    #                 return decorator                                                         <-'
                
    #             def function3_decorator(self, example_function3):            
    #                 def decorator(*args ,**kwargs):                
    #                     print ('Inside the decorator for function3 with args: ', args)
    #                     return example_function3(*args , **kwargs)
    #                 return decorator



    # CREATE THE FUNCTION DEF FOR  __getattribute__(self, attr_name):
    finalfunc = ast.FunctionDef(args=ast.arguments(args=[ast.Name(ctx=ast.Param(), 
                                                                        id='self'), 
                                                        ast.Name(ctx=ast.Param(), 
                                                        id='attr_name')], 
                                                                       defaults=[], 
                                                                       kwarg=None, 
                                                                       vararg=None), 
                                                        body=body1, #ADD ALL THE IF STATEMENTS AND SUPER CALL TO THIS FUNCTION - BODY1
                                                        decorator_list=[], 
                                                        name='__getattribute__')
    listfuns.append(finalfunc) #append the __getattribute__ function so we have all the decorators and a way to call them

    
    # this class definition is what the Class_builder function will return, it is the actual decorated class
    # class decorated_example(cls):  <---MAKING THIS AND ADDING ITS BODY
    classDec = ast.ClassDef(bases= [ ast.Name(ctx=ast.Load(), id='cls') ] , 
                            body=  listfuns,   # ADD IN THE FUNCTION WE CREATED ABOVE AND ALL FROM getMethodDecorators() 
                            decorator_list=[], 
                            name=NewClass)     # NAME THIS CLASS decorated_classname
    
    # outside funtion is class_decorator inside funtion is class_rebuilder
    # def class_decorator(*method_names):       <-.
    #     def class_rebuilder(cls):              <---.
    #           ...                               <--- MAKING THESE
    #         return decorated_example           <---'
    #     return class_rebuilder                <-'
    functiondefs = ast.FunctionDef(args=ast.arguments(args=[], 
                                        defaults=[], 
                                        kwarg=None, 
                                        vararg='method_names'), 
                        body=[ast.FunctionDef(args=ast.arguments(args=[ast.Name(ctx=ast.Param(), 
                                                                     id='cls')], 
                                                          defaults=[], 
                                                          kwarg=None, 
                                                          vararg=None), 
                                            body=[classDec, ast.Return(value=ast.Name(ctx=ast.Load(), id=NewClass))], #add appropriate name
                                            decorator_list=[], 
                                            name='class_rebuilder'),
                                            ast.Return(value=ast.Name(ctx=ast.Load(), id='class_rebuilder'))], 
                        decorator_list=[], 
                        name='class_decorator')

    return functiondefs # this is a function containing everything we have done, thats it the whole shabang 

#######################################################
#TOKENIZER SO THAT WE MAY PRESERVE (ISH) THE COMMENTS # 
#######################################################
def token(filew):
    str = ""
    filename = "%s" % (filew)
    f = open(filename)
    previous = 0;
    source = []
    start = None
    currentLine = -1
    indents = ["","","","","","","","","","","","","","",""]
    numTok=0
    lookingForFirstCodeToken = False
    for i in tokenize.generate_tokens(f.readline):
        #print i[0]
        pas=True
        numTok+=1
        if i[2][0] != currentLine:
            #print i
            currentLine = i[2][0]
            source.append(i[4])
            index=len(source)-1
            numTok= 1
            lookingForFirstCodeToken = True
        if lookingForFirstCodeToken == True and (i[0]>6 or i[0]<4):
            start = i[2][1]
            lookingForFirstCodeToken = False
        if i[0] == 5:
            numTok-=1
        if i[0] ==6:
            numTok-=1
        if i[0] == 53:
            numTok-=1
            col = i[2][1]
            comment = i[4]
            comment = comment[col:-1]
            comment = comment.replace("\'","\\\'").replace("\"","\\\"")
            #print numTok
            if numTok > 0:
                source[index] = "{}\"#BELOW LINE:{}\"\n{}\n".format(i[4][:start] ,comment,i[4][:col])
            else:
                source[index] = "{}\"#COMMENT:{} \" \n".format(i[4][:col],comment)
        previous = i[0]


    f.close()
    newfile = "{}{}".format(filename[:-3],"_COM.py")
    outputfile = open(newfile,'w+')
    joe = str.join(source)
    outputfile.write(joe)
    outputfile.close()
##################################################
# UNDOES THE "#COMMENT" TO PRODUCE ORIGINAL CODE #
##################################################
def findandreplace(filename):
    source = ""
    with open(filename) as fp:
        lineNumber = 0
        addComment = ""

        for line in fp:
            lineNumber += 1
            index = 0

            if addComment != "":
                line = line[:-1] + " " + addComment
                addComment = ""

            for index in xrange(0,len(line)):
                changedLine = ""
                if line[index] == "'" or line[index] == '"':
                    quoteIndex = index

                    if line[index+1:index+10] == "#COMMENT:":
                        changedLine = line[:index]
                        changedLine += line[index+10:-2]
                        changedLine += "\n"
                        line = changedLine
                        break;

                    if line[index+1:index+13] == "#BELOW LINE:":
                        addComment = line[index+13:-2] + "\n"
                        line = ""
                        break;
                    for quoteIndex in xrange(index,len(line)):
                        if line[quoteIndex:quoteIndex+9] == "#COMMENT:":
                            commentLen = len(line) - quoteIndex
                            addComment = line[quoteIndex+9:-2] + "\n"
                            line = line[:-commentLen] + "' " + addComment
                            addComment = ""
                            break;
                    break;
            source += line
    newFileName = filename[:-4]+"3.py"
    outputfile = open(newFileName,'w+')
    outputfile.write(source)        #write our new source code to a file
    outputfile.close()
    return newFileName

if __name__ == "__main__":
    ##########################################
    # INCASE THIS FILE IS RUN WITH OUT A GUI #
    ##########################################
    if len(sys.argv) is 1:
        arguementInput().cmdloop()
    else:
        app = QtGui.QApplication(sys.argv)
        ex = GuiInput()
        sys.exit(app.exec_())


